chiark / gitweb /
setup: Help finding locally installed libraries.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22   case "$1" in
23     -x) xstuff=t;;
24     -n) false=false;;
25     --) shift; break;;
26     -*) echo >&2 "$0: bad option"; exit 1;;
27     *) break;;
28   esac
29   shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41   echon="echo -n"
42   echoc=""
43 else
44   echon="echo"
45   echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51   GETURL="curl -fs -o"
52   echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54   GETURL="wget -q -O"
55   echo " wget."
56 else
57   echo " failed!"
58   echo >&2 "$0: failed to find URL fetcher"
59   exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67   $echon "  $i:$echoc"
68   if [ -d $HOME$sub/$i ]; then
69     echo " already exists."
70   else
71     mkdir -p $HOME$sub/$i
72     echo " done."
73   fi
74 done
75 echo "  all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82   mlib:crc-mktab
83   checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86   xtoys:xatom
87 "
88 for system in $systems; do
89   set -- $(echo $system | tr : ' ')
90   sys=$1 prog=$2
91   $echon "  $sys:$echoc"
92   if $false $prog >/dev/null 2>&1 --version; then
93     echo " already installed."
94   else
95     ( set -e
96       $echon " downloading$echoc"
97       cd $HOME$sub/src
98       rm -rf $sys.tar.gz $sys-$ver
99       $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100       $echon " unpacking$echoc"
101       dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102       gzip -cd $sys.tar.gz | tar xf -
103       $echon " configuring$echoc"
104       cd $dir
105       mkdir build
106       cd build
107       ../configure \
108         --prefix=$HOME$sub \
109         PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110         >>buildlog 2>&1
111       $echon " building$echoc"
112       make >>buildlog 2>&1
113       $echon " installing$echoc"
114       make install >>buildlog 2>&1
115       echo " done."
116     )
117   fi
118 done
119 echo "  all done."
120
121 ###--------------------------------------------------------------------------
122 ### Install global configuration.
123
124 echo -n "Installing dotfile configuration:"
125 if [ -f $HOME$sub/.mdw.conf ]; then
126   echo " already installed."
127 else
128   cp mdw.conf $HOME$sub/.mdw.conf
129   echo " done."
130 fi
131
132 ## Symlink the various dotfiles into place
133 dotfiles="
134   bash_profile bash_logout bashrc inputrc bash_completion
135   emacs emacs-calc vm gnus.el ercrc.el
136   vimrc mg zile
137   ditz-config
138   mailrc signature
139   cgrc tigrc
140   gdbinit
141   guile
142   rcrc
143   toprc
144   mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
145   aspell.conf
146   tclshrc:.tclshrc tclshrc:.wishrc
147   lisp-init.lisp:.cmucl-init.lisp
148     lisp-init.lisp:.sbclrc
149     lisp-init.lisp:.clisprc.lisp
150     lisp-init.lisp:.eclrc
151   swank.lisp
152   dircolors colordiffrc screenrc cvsrc indent.pro"
153 [ "$xstuff" ] && dotfiles="$dotfiles
154   xinitrc xsession Xdefaults vncrc vncsession
155   fonts.conf
156   stalonetrayrc
157   putty-defaults:.putty/sessions/Default%20Settings
158   mdw.session:.config/gnome-session/sessions/mdw.session
159   eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
160   e-keybindings.cfg:.enlightenment/keybindings.cfg
161   evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
162   e16-bindings:.e16/bindings.cfg"
163 echo "Installing dotfiles..."
164 for d in $dotfiles; do
165   target=.$d
166   case $d in
167     *:*) target=${d#*:} d=${d%%:*};;
168   esac
169   ft=$HOME$sub/$target
170   dir=${ft%/*}
171   mkdir -p $dir
172   ln -s $here/dot/$d $ft.new
173   mv $ft.new $ft
174   echo "  $target"
175 done
176 echo "  all done."
177
178 ## Substitute things which need substituting.
179 dotfilessubst="
180   gitconfig
181   pulse-default.pa.in:.pulse/default.pa"
182 echo "Installing dotfiles with substitutions..."
183 for d in $dotfilessubst; do
184   case $d in
185     *:*) target=${d#*:} d=${d%%:*};;
186     *) target=.$d d=$d.in;;
187   esac
188   ft=$HOME$sub/$target
189   dir=${ft%/*}
190   mkdir -p $dir
191   sed "
192 1i\\
193 ### generated by $here/setup; do not edit!\\
194
195 /@home@/ s\a\a$HOME\ag
196 /@profile@/ s\a\a$here\ag
197 /@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
198 " dot/$d >$ft.new
199   mv $ft.new $ft
200   echo "  $target"
201 done
202 echo "  all done."
203
204 ## Symlink backgrounds.
205 backgrounds="
206   jue-peek.jpg
207   medusa.jpg
208   bsg-supper.jpg
209   rayne.jpg
210   hypatia.jpg
211   noodly.jpg
212   lovelace.jpg"
213 if [ "$xstuff" ]; then
214   echo "Installing backgrounds..."
215   for b in $backgrounds; do
216     for e in enlightenment e16; do
217       dir=$HOME$sub/.$e/backgrounds
218       t=$dir/$b
219       mkdir -p $dir
220       ln -s $here/bg/$b $t.new
221       mv $t.new $t
222     done
223     echo "  $b"
224   done
225   echo "        all done."
226 fi
227
228 ###--------------------------------------------------------------------------
229 ### Install useful scripts included in this package.
230
231 scripts="
232   mdw-editor
233   mdw-pager
234   mdw-conf
235   mdw-build
236   emacsclient-hack
237   movemail-hack
238   sendmail-hack
239   aspell-hack
240   emerge-hack
241   lesspipe.sh
242   start-ssh-agent
243   svnwrap
244   hyperspec"
245 [ "$xstuff" ] && scripts="$scripts
246   xinitcmd
247   un-backslashify-selection
248   lock-screen
249   xshutdown"
250 echo "Installing scripts..."
251 mkdir -p $HOME$sub/bin
252 for s in $scripts; do
253   ft=$HOME$sub/bin/$s
254   ln -s $here/bin/$s $ft.new
255   mv $ft.new $ft
256   echo "  $s"
257 done
258 echo "  all done."
259
260 hacks="
261   ssh:ssh"
262 echo "Installing hacks..."
263 for h in $hacks; do
264   d=${h%%:*} h=${h#*:}
265   ft=$HOME$sub/bin/hacks/$d
266   mkdir -p $ft
267   ln -s $here/hacks/$h $ft/$h.new
268   mv $ft/$h.new $ft/$h
269   echo "  $d:$h"
270 done
271 echo "  all done."
272
273 ###--------------------------------------------------------------------------
274 ### Set up the Emacs config.
275
276 $echon "Finding a suitable emacs:$echoc"
277 emacs=no
278 for i in emacs22 emacs23 emacs21 emacs; do
279   if type -p >/dev/null $i; then
280     emacs=$i
281     break
282   fi
283 done
284 if [ $emacs = no ]; then
285   echo " failed."
286   emacs=:
287 else
288   echo " $emacs."
289 fi
290
291 echo "Installing Emacs packages..."
292 emacspkg="
293   make-regexp
294   ew-hols
295   mdw-gnus-patch
296   git git-blame vc-git stgit
297   quilt"
298 for elib in $emacspkg; do
299   $echon "  $elib:$echoc"
300   if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
301        (progn
302          (setq load-path (nconc load-path (list "~/lib/emacs")))
303          (kill-emacs (condition-case nil
304                          (progn (load-library "'"$elib"'") 0)
305                        (error 1))))'; then
306     echo " already installed."
307   else
308     if [ -f el/$elib.el ]; then
309       cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
310     else
311       $echon " downloading$echoc"
312       $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
313     fi
314     $echon " compiling$echoc"
315     (cd $HOME$sub/lib/emacs;
316       $emacs >/dev/null 2>&1 --no-site-file --batch \
317         --eval '(byte-compile-file "'"$elib.el"'")')
318     echo " done."
319   fi
320 done
321 echo "  all done."
322
323 $echon "Setting up Emacs configuration:$echoc"
324 $echon " linking$echoc"
325 for f in dot-emacs.el Makefile; do
326   set -- $(echo $link | tr : ' ')
327   ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
328   mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
329 done
330 $echon " compiling$echoc"
331 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
332 echo " done."
333
334 ###----- That's all, folks --------------------------------------------------